import type { AnyAbility } from "@casl/ability";
import type { Application, HookContext } from "@feathersjs/feathers";
import type { Adapter, AuthorizeHookOptions, HookBaseOptions, Path, ThrowUnlessCanOptions } from "../../types";
export declare const makeOptions: (app: Application, options?: Partial<AuthorizeHookOptions>) => AuthorizeHookOptions;
export declare const makeDefaultOptions: (options?: Partial<AuthorizeHookOptions>) => AuthorizeHookOptions;
export declare const getAdapter: (app: Application, options: Pick<AuthorizeHookOptions, "adapter">) => Adapter;
export declare const getAbility: (context: HookContext, options?: Pick<HookBaseOptions, "ability" | "checkAbilityForInternal">) => Promise<AnyAbility | undefined>;
export declare const throwUnlessCan: (ability: AnyAbility, method: string, resource: string | Record<string, unknown>, modelName: string, options: Partial<ThrowUnlessCanOptions>) => boolean;
export declare const handleConditionalSelect: (context: HookContext, ability: AnyAbility, method: string, modelName: string) => boolean;
export declare const getConditionalSelect: ($select: string[], ability: AnyAbility, method: string, modelName: string) => undefined | string[];
export declare const checkMulti: (context: HookContext, ability: AnyAbility, modelName: string, options?: Pick<AuthorizeHookOptions, "actionOnForbidden">) => boolean;
export declare const hide$select: (context: HookContext) => unknown;
export declare const restore$select: (context: HookContext) => string[] | undefined;
export declare const get$select: (context: HookContext) => unknown;
export declare const setPersistedConfig: (context: HookContext, key: Path, val: unknown) => HookContext;
export declare const getPersistedConfig: (context: HookContext, key: Path) => unknown;
